/***********************************************************************
*     ACCESS SAMPLE PROGRAM                                            *
*                                                             BY CAD'S *
*                                                                      *
*          The program of output the coordinate value of the points    *
*                                                                      *
***********************************************************************/

#include <stdio.h>
#include <direct.h>
#include <windows.h>
#include "accfnc.h"

#define INCL_BLK_MSG_SP8
#include "getptmsg.dfn"

void ac2userp( void )
{
    long    iflgar[3];                  /* bubegn       */
    long    ioutar[3];                  /* bubegn       */
    long    modear[3];                  /* bumode       */
    long    prsbtn;                     /* msgbox       */
    long    msgblk = 0L;
    long    save_ivudet;                /* bucds        */
    long    istart, istop;              /* butgrp       */
    long    mptrln, mptrar[2];          /* butgrp       */
    long    outnum;                     /* mmcdfl2      */
    long    istndx, itype;              /* bufnd2       */
    long    iatno, index, matr;         /* bufnd2       */
    long    lenerr, ierrar[2];          /* budspe       */
    long    ptnum;
    long    numptr;
    long    *nptrar=NULL, *ptptrar=NULL;
    long    ii;
    long    pos;
    long    number;
    short   retc;
    double  xpt, ypt;                   /* gtpt         */
    char    filterstr[256+1];           /* mmcdfl2      */
    char    filtername[256+1];          /* mmcdfl2      */
    char    outfl[512] = "";            /* mmcdfl2      */
    char    infl[512] = "";             /* mmcdfl2      */
    char    WorkBuf[256+1];
    char    csv_str[256+1];
    FILE    *FilePtr = NULL;

    /* Initial of ACCESS and Set Trace Mode */
    iflgar[0] = 52L;
    iflgar[1] = 0L;
    iflgar[2] = 0L;
    retc = MC_bubegn ( 1L, iflgar, ioutar, 10L );
    if ( retc ) goto exit;

    modear[0] = 2L;
    modear[1] = 0L;
    modear[2] = 12L;
    retc = MC_bumode ( 1L, modear, 10L );
    if ( retc ) goto exit;

    /* Open Resource File */
    retc = MC_msginit ( 8L, "getptmsg" );
    if ( retc ) goto exit;

    /* Set the block of message */
    retc = MC_msgsetbk ( BLK_MSG_SP8 );
    if ( retc ) goto exit;
    msgblk = 1L;

    /* Save Current View */
    MC_bucds( 2L, 1L, 1L, &save_ivudet, &number, 10 );
    if ( save_ivudet == 1000L ) save_ivudet = 0L;

    /* Check Group Elements */
    istart = 0L;
    istop = 0L;
    mptrln = 0L;
    MC_butgrp ( 900L, 1L, istart, istop, mptrln, mptrar, &numptr, nptrar, 5L );
    if ( numptr == 0 )
    {
        MC_msgbox ( MSG_NOT_FOUND_GROUP, 1L, 1L, &prsbtn );
        goto exit;
    }

    nptrar = malloc ( numptr * sizeof(long) );
    ptptrar = malloc ( numptr * sizeof(long) );
    if ( nptrar == NULL || ptptrar == NULL )
    {
        MC_msgbox ( MSG_OUT_OF_MEMORY, 1L, 1L, &prsbtn );
        goto exit;
    }

    MC_butgrp ( 5L, 1L, istart, istop, mptrln, mptrar, &numptr, nptrar, 5L );

    /* Check Point Elements */
    istndx = 1L;
    itype = 100L;
    ptnum = 0L;
    iatno = 0L;
    for ( ; ; )
    {
        retc = MC_bufnd2 ( 1L, 1L, numptr, nptrar, istndx, &itype, iatno, &index, &matr, 20L );
        if ( retc != 0 ) break;
        istndx = index+1;

        if ( MC_bivdt ( 1L, nptrar[index-1] ) != save_ivudet ) continue;

        ptptrar[ptnum] = nptrar[index-1];
        ptnum++;
    }

    if ( ptnum == 0L )
    {
        MC_msgbox ( MSG_NOT_FOUND_GROUP, 1L, 1L, &prsbtn );
        goto exit;
    }

    for ( ii=0; ii<ptnum; ii++ )
    {
        MC_budspe ( 2L, 1L, 1L, &ptptrar[ii], 1L, &lenerr, ierrar, 1L );
    }

    memset ( infl, 0x00, sizeof(infl) );
    memset ( outfl, 0x00, sizeof(outfl) );

    _getcwd ( infl, 512 );

    /* *.CSV */
    memset ( filterstr, 0x00, sizeof(filterstr) );
    strcpy ( filterstr, "CSV (*.csv)" );
    memset ( filtername, 0x00, sizeof(filtername) );
    strcpy ( filtername, "*.csv" );

    retc = MC_mmcdfl2 ( 1L, (long)strlen(infl), infl, 2L, filterstr, filtername, &outnum, outfl );

    /* _vf̒ʏ\ */
    for ( ii=0; ii<ptnum; ii++ )
    {
        MC_budspe ( 2L, 1L, 1L, &ptptrar[ii], 0L, &lenerr, ierrar, 1L );
    }

    if ( retc != 0 )
    {
        MC_msgbox ( MSG_END_PROCESS, 1L, 1L, &prsbtn );
        goto exit;
    }

    FilePtr = fopen( outfl, "wb" );
    if ( FilePtr == NULL )
    {
        MC_msgbox ( MSG_FILE_OUTPUT_ERROR, 1L, 1L, &prsbtn );
        goto exit;
    }


/*-------------------*/
/*  Create CSV File  */
/*-------------------*/
    for ( ii=0; ii<ptnum; ii++ )
    {
        pos = 0;
        memset ( csv_str, 0x00, sizeof(csv_str) );
        MC_gtpt ( 1L, ptptrar[ii], &xpt, &ypt );
        
        memset ( WorkBuf, 0x00, sizeof(WorkBuf) );
        sprintf ( WorkBuf, "%8.6f", xpt );
        memcpy ( &csv_str[pos], WorkBuf, strlen(WorkBuf) );
        pos += (long)strlen ( WorkBuf );

        csv_str[pos] = 0x2c;
        pos++;

        memset ( WorkBuf, 0x00, sizeof(WorkBuf) );
        sprintf ( WorkBuf, "%8.6f", ypt );
        memcpy ( &csv_str[pos], WorkBuf, strlen(WorkBuf) );
        pos += (long)strlen ( WorkBuf );

        csv_str[pos] = 0x0d;
        pos++;
        csv_str[pos] = 0x0a;
        pos++;

        if ( fwrite ( csv_str, pos, 1, FilePtr ) == -1 )
        {
            fclose ( FilePtr );
            MC_msgbox ( MSG_FILE_OUTPUT_ERROR, 1L, 1L, &prsbtn );
            goto exit;
        }
    }
    fclose ( FilePtr );

    MC_msgbox ( MSG_FILE_OUTPUT, 1L, 1L, &prsbtn );


exit:

    if ( nptrar != NULL ) free ( nptrar );
    if ( ptptrar != NULL ) free ( ptptrar );

    /* End of Message Block */
    if ( msgblk ) MC_msgendbk( BLK_MSG_SP8 );

    MC_buend ( 1L, 10L );

    return;
}

